import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JTextField;

/**
 * Graphics - A graphics coursework in Java.
 *
 * I declare this work is mine in its entirety with the exception
 * of template code provided by Dr. Mark Jones of Swansea University.
 * 
 * @author Sean Handley (320097@swan.ac.uk)
 * @version 2006-02
 * 
 */
public class CreateFilter extends JDialog {
	private static final long serialVersionUID = 1L;
	
	public ArrayList textFields;
	public JButton save_button, cancel_button;
	public BufferedWriter writer;
	public String path;
	
	public int M, N;
	
	public CreateFilter(String title) {
		super();
		setTitle(title);
	}
	public String make(int N, int M) {
		path = "";
		
		this.M = M;
		this.N = N;
		
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());
		
		Container topPane = new Container();
		topPane.setLayout(new GridLayout(M,N));
		
		Container botPane = new Container();
		botPane.setLayout(new FlowLayout());
		
		//use an array list to refer to dynamic text fields
		textFields = new ArrayList();
		
		for(int i = 0; i < M; i++) {
			for(int j = 0; j < N; j++) {
				JTextField textField = new JTextField();
				textFields.add(textField);
				topPane.add(textField);
			}
		}
		
		save_button = new JButton("Save");
		botPane.add(save_button);
		
		cancel_button = new JButton("Cancel");
		botPane.add(cancel_button);
		
		contentPane.add(topPane, BorderLayout.NORTH);
		contentPane.add(botPane, BorderLayout.SOUTH);
		
		GUIEventHandler handler = new GUIEventHandler();
		
		save_button.addActionListener(handler);
		cancel_button.addActionListener(handler);
		
		pack();
		setLocationRelativeTo(null);
		setVisible(true);
		
		return path;
	}
	
	public class GUIEventHandler implements ActionListener{
		public void actionPerformed(ActionEvent event) {
			if(event.getSource() == save_button) {
				saveIt();
				dispose();
			} else if(event.getSource() == cancel_button) {
				dispose();
			}
		}	
	}
	
	private void saveIt() {
		//save the filter
		String filename = "filter.fil";
		String selFile = "";
		
		JFileChooser fc = new JFileChooser(new File(filename));
		
		// Show open dialog; this method does not return until the dialog is closed
		fc.showSaveDialog(rootPane);
		try {
			selFile = fc.getSelectedFile().toString();
			path = selFile;
		}
		catch(NullPointerException e) {
			//do nothing
		}
		
		try {
			writer = new BufferedWriter(new FileWriter(selFile));
			String line = "";
			
			for(int i = 1; i <= textFields.size(); i++) {
				//set the line to be the first element of the row
				if((i % N) != 0) {
					line += ((JTextField) textFields.get(i-1)).getText();
					line += ":";
				} else {
					//when the line is complete, write it out to the file
					line += ((JTextField) textFields.get(i-1)).getText();
					writer.write(line);
					writer.newLine();
					line = "";
				}
			}
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			try {
				writer.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
